package com.nisum.backpressureStrategy;
import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class ElementSubscriber implements Flow.Subscriber<Integer> {
    private Flow.Subscription subscription;

    @Override
    public void onSubscribe(final Flow.Subscription subscription) {
        this.subscription = subscription;
        subscription.request(1);
    }

    @Override
    public void onNext(final Integer elementNumber) {
        log.info(Thread.currentThread().getName()+"==="+" I got a new element in ElementSubscriber: " + elementNumber+" :Now wait till I give next Instruction");
        processingRequest(elementNumber);
        log.info(Thread.currentThread().getName()+"==="+"Get next element ");
        subscription.request(1);
    }

    @Override
    public void onError(final Throwable throwable) {
        log.error("Oops I got an error from the Publisher: " + throwable.getMessage());
    }

    @Override
    public void onComplete() {
        log.info("Completed");
    }

    private void processingRequest(int number) {
        try {
            log.info("Processing my number inside ElementSubscriber::"+number);
            Thread.sleep(1000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
}
