package com.nisum.backpressureStrategy;
import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.Flow;

@Slf4j
public class EndSubscriber<T> implements Flow.Subscriber<T> {

    private Flow.Subscription subscription;

    @Override
    public void onSubscribe(Flow.Subscription subscription) {
        this.subscription = subscription;
        subscription.request(2);
    }

    @Override
    public void onNext(T item) {

        log.info(Thread.currentThread().getName()+"==="+" I got a new element in EndSubscriber: " + item+" :Now wait till I give next Instruction");
        processingRequest(item);
        subscription.request(1);

    }
    @Override
    public void onError(Throwable throwable) {
        log.error(Thread.currentThread().getName() + " | ERROR = "
                + throwable.getClass().getSimpleName() + " | " + throwable.getMessage());
    }

    @Override
    public void onComplete() {
        log.info("Completed");
    }

    private void processingRequest(T number) {
        try {
            log.info("Processing my number inside EndSubscriber::"+number);
            Thread.sleep(2000);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
    }
}
