package com.nisum.publishers;

import com.nisum.subscribers.CustomerSubscriber;
import lombok.extern.slf4j.Slf4j;

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.SubmissionPublisher;

@Slf4j
public class SubmissionPublisherOfferMethod {
    public static void main(String[] args) throws InterruptedException {


        SubmissionPublisher<String> publisher =
                new SubmissionPublisher<>(ForkJoinPool.commonPool(), 16);


        publisher.subscribe(new CustomerSubscriber<>());

        for(int i = 0; i < 10; i++) {
                int result = publisher.offer("item" + i, (subscriber, value) -> {
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                return false;
            });


            if(result < 0) {
                System.err.println("dropped: " + result);
            }
        }
        Thread.sleep(10000);
        publisher.close();
    }
}
